/* Simple tty plotting for c* programs - either Sun or VT100 */

#include <stdio.hs>

/* Maximum sizes for display */

#define MXHT 50
#define MXWD 120

int iht, iwd;     /* Current hight, width of display */

char img[MXHT][MXWD+1];  /* The image */

/* Initialize the array to blanks, ht x wd */

void start_image(ht, wd)
  int ht, wd;
  {int i, j;
   if ( ht > MXHT || wd > MXWD)
       { printf("Image too large.\n"); return; };
   for ( i = 0; i < ht; i++ )
    { for ( j = 0; j < wd; j++ ) img[i][j] = ' ';
      img[i][j] = '\0';
    };
   iht = ht;  iwd = wd;
  }

/* Insert string s in row i starting at col j */

void hinsrt(s, i, j)
  char *s; int i, j;
  { for ( ; *s != '\0' ; s++, j++ ) img[i][j] = *s; }

/* Insert string s in col j starting in row i */

void vinsrt(s, i, j)
  char *s; int i, j;
  { for ( ; *s != '\0' ; s++, i++ ) img[i][j] = *s; }

/* Insert horizontal rule in row i starting in col j of width w */

void hrule(i, j, w)
  int i, j, w;
  {int k;
   for ( k = 0; k < w; k++, j++ )
    img[i][j] = ( img[i][j] == '|' ) ? '+' : '-';
  }

/* Insert vertical rule staring at row i col j of height h */

void vrule(i, j, h)
  int i, j, h;
  {int k;
   for ( k = 0; k < h; k++, i++ )
    img[i][j] = ( img[i][j] == '-' ) ? '+' : '|';
  }

/* Print current image. */

void primg()
  {int i;
   for ( i = 0; i < iht; i++ ) printf("%s\n", img[i]);
  }

/* Clear image to blanks */

void clrimg()
 { start_image(iht, iwd); }

/* Insert string s centered in field starting at i, j of width w */

void center(s, i, j, w)
  char *s;  int i, j, w;
  { hinsrt(s, i, j + 1 + ((w - strlen(s)) >> 1)); }





